Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformSolutionCoord.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformSolutionCoord.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformSolutionCoord.cpp	(revision 12878)
@@ -4,10 +4,10 @@
 #include "./elements.h"
 
-void TransformSolutionCoord(double* solution,Node** nodes,int numnodes,int cs_enum){
+void TransformSolutionCoord(IssmDouble* solution,Node** nodes,int numnodes,int cs_enum){
 
 	int* cs_array=NULL;
 
 	/*All nodes have the same Coordinate System*/
-	cs_array=(int*)xmalloc(numnodes*sizeof(int));
+	cs_array=xNew<int>(numnodes);
 	for(int i=0;i<numnodes;i++) cs_array[i]=cs_enum;
 
@@ -16,13 +16,13 @@
 
 	/*Clean-up*/
-	xfree((void**)&cs_array);
+	xDelete<int>(cs_array);
 }
 
-void TransformSolutionCoord(double* solution,Node** nodes,int numnodes,int* cs_array){
+void TransformSolutionCoord(IssmDouble* solution,Node** nodes,int numnodes,int* cs_array){
 
 	int     i,j;
 	int     numdofs   = 0;
-	double *transform = NULL;
-	double *values    = NULL;
+	IssmDouble *transform = NULL;
+	IssmDouble *values    = NULL;
 
 	/*Get total number of dofs*/
@@ -31,10 +31,10 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error_("Coordinate system %s not supported yet",EnumToStringx(cs_array[i]));
+			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
 
 	/*Copy current solution vector*/
-	values=(double*)xmalloc(numdofs*sizeof(double));
+	values=xNew<IssmDouble>(numdofs);
 	for(i=0;i<numdofs;i++) values[i]=solution[i];
 
@@ -47,6 +47,6 @@
 				&solution[0],0);
 
-	/*Free Matrix*/
-	xfree((void**)&transform);
-	xfree((void**)&values);
+	/*Free Matrices*/
+	xDelete<IssmDouble>(transform);
+	xDelete<IssmDouble>(values);
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformStiffnessMatrixCoord.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformStiffnessMatrixCoord.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/TransformStiffnessMatrixCoord.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 
 	/*All nodes have the same Coordinate System*/
-	cs_array=(int*)xmalloc(numnodes*sizeof(int));
+	cs_array=xNew<int>(numnodes);
 	for(int i=0;i<numnodes;i++) cs_array[i]=cs_enum;
 
@@ -16,5 +16,5 @@
 
 	/*Clean-up*/
-	xfree((void**)&cs_array);
+	xDelete<int>(cs_array);
 }
 
@@ -23,6 +23,6 @@
 	int     i,j;
 	int     numdofs   = 0;
-	double *transform = NULL;
-	double *values    = NULL;
+	IssmDouble *transform = NULL;
+	IssmDouble *values    = NULL;
 
 	/*Get total number of dofs*/
@@ -31,10 +31,10 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error_("Coordinate system %s not supported yet",EnumToStringx(cs_array[i]));
+			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
 
 	/*Copy current stiffness matrix*/
-	values=(double*)xmalloc(Ke->nrows*Ke->ncols*sizeof(double));
+	values=xNew<IssmDouble>(Ke->nrows*Ke->ncols);
 	for(i=0;i<Ke->nrows;i++) for(j=0;j<Ke->ncols;j++) values[i*Ke->ncols+j]=Ke->values[i*Ke->ncols+j];
 
@@ -49,5 +49,5 @@
 
 	/*Free Matrix*/
-	xfree((void**)&transform);
-	xfree((void**)&values);
+	xDelete<IssmDouble>(transform);
+	xDelete<IssmDouble>(values);
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/Elements/elements.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Elements/elements.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Elements/elements.h	(revision 12878)
@@ -4,19 +4,27 @@
 
 #ifndef _SHARED_ELEMENTS_H_
-#define  _SHARED_ELEMENTS_H_
+#define _SHARED_ELEMENTS_H_
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 class ElementMatrix;
 class ElementVector;
 
-double Paterson(double temperature);
-double Arrhenius(double temperature,double depth,double n);
-void   GetVerticesCoordinates(double* xyz,  Node** nodes, int numvertices);
+IssmDouble Paterson(IssmDouble temperature);
+IssmDouble Arrhenius(IssmDouble temperature,IssmDouble depth,IssmDouble n);
+IssmDouble PddSurfaceMassBlance(IssmDouble* monthlytemperatures,  IssmDouble* monthlyprec, IssmDouble* pdds, IssmDouble* pds, 
+				IssmDouble signorm, IssmDouble yts, IssmDouble h, IssmDouble s, IssmDouble rho_ice, IssmDouble rho_water);
+void ComputeDelta18oTemperaturePrecipitation(IssmDouble Delta18oSurfacePresent, IssmDouble Delta18oSurfaceLgm, IssmDouble Delta18oSurfaceTime,
+				     IssmDouble Delta18oPresent, IssmDouble Delta18oLgm, IssmDouble Delta18oTime, 
+				     IssmDouble* PrecipitationsPresentday,
+				     IssmDouble* TemperaturesLgm, IssmDouble* TemperaturesPresentday, 
+					     IssmDouble* monthlytemperaturesout, IssmDouble* monthlyprecout);
+void   GetVerticesCoordinates(IssmDouble* xyz,  Node** nodes, int numvertices);
 int    GetNumberOfDofs( Node** nodes,int numnodes,int setenum,int approximation_enum);
 int*   GetLocalDofList( Node** nodes,int numnodes,int setenum,int approximation_enum);
 int*   GetGlobalDofList(Node** nodes,int numnodes,int setenum,int approximation_enum);
+
 #ifdef _HAVE_DIAGNOSTIC_
-void   CoordinateSystemTransform(double** ptransform,Node** nodes,int numnodes,int* cs_array);
+void   CoordinateSystemTransform(IssmDouble** ptransform,Node** nodes,int numnodes,int* cs_array);
 void   TransformInvStiffnessMatrixCoord(ElementMatrix* Ke,Node** nodes,int numnodes,int cs_enum);
 void   TransformInvStiffnessMatrixCoord(ElementMatrix* Ke,Node** nodes,int numnodes,int* cs_array);
@@ -25,37 +33,11 @@
 void   TransformLoadVectorCoord(ElementVector* pe,Node** nodes,int numnodes,int cs_enum);
 void   TransformLoadVectorCoord(ElementVector* pe,Node** nodes,int numnodes,int* cs_array);
-void   TransformSolutionCoord(double* solution,Node** nodes,int numnodes,int cs_enum);
-void   TransformSolutionCoord(double* solution,Node** nodes,int numnodes,int* cs_array);
+void   TransformSolutionCoord(IssmDouble* solution,Node** nodes,int numnodes,int cs_enum);
+void   TransformSolutionCoord(IssmDouble* solution,Node** nodes,int numnodes,int* cs_array);
 #endif
 
-inline void printarray(double* array,int lines,int cols=1){
-	printf("\n");
-	for(int i=0;i<lines;i++){  
-		printf("   [ ");
-		for(int j=0;j<cols;j++) printf(" %12.7g ",array[i*cols+j]);
-		printf(" ]\n");
-	}  
-	printf("\n");
-}
-inline void printarray(int* array,int lines,int cols=1){
-	printf("\n");
-	for(int i=0;i<lines;i++){  
-		printf("   [ ");
-		for(int j=0;j<cols;j++) printf(" %6i",array[i*cols+j]);
-		printf(" ]\n");
-	}  
-	printf("\n");
-}
-inline void printbinary(int n) {
-	unsigned int i=1L<<(sizeof(n)*8-1);
-
-	while (i>0) {
-		if (n&i)
-		 printf("1");
-		else
-		 printf("0");
-		i>>=1;
-	}
-}
-
+/*Print arrays*/
+void printarray(IssmPDouble* array,int lines,int cols=1);
+void printarray(int* array,int lines,int cols=1);
+void printbinary(int n);
 #endif //ifndef _SHARED_ELEMENTS_H_
Index: issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/Exceptions.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/Exceptions.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/Exceptions.cpp	(revision 12878)
@@ -20,5 +20,5 @@
 }
 
-ErrorException::ErrorException(string what_file,string what_function,int what_line,string what_arg){
+ErrorException::ErrorException(const string& what_file, const string& what_function,int what_line, const string& what_arg){
 
 	what_str=what_arg;
@@ -44,14 +44,14 @@
 
 	if (function_name=="" || file_line==0){ //WINDOWS
-		printf("%s%s","Error message: ",what());
+		_printString_("Error message: " << what());
 	}
 	else{
 		if(num_procs==1){
-			printf("\n??? Error using ==> %s:%i\n",file_name.c_str(),file_line);
-			printf("%s error message: %s\n\n",function_name.c_str(),what());
+			_printLine_("\n??? Error using ==> " << file_name.c_str() << ":" << file_line);
+			_printLine_(function_name.c_str() << " error message: " << what() << "\n");
 		}
 		else{
-			printf("\n[%i] ??? Error using ==> %s:%i\n",my_rank,file_name.c_str(),file_line);
-			printf("[%i] %s error message: %s\n\n",my_rank,function_name.c_str(),what());
+			_printLine_("\n[" << my_rank << "] ??? Error using ==> " << file_name.c_str() << ":" << file_line);
+			_printLine_("[" << my_rank << "] " << function_name.c_str() << " error message: " << what() << "\n");
 		}
 	}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/exceptions.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/exceptions.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/exceptions.h	(revision 12878)
@@ -24,5 +24,5 @@
 	public:
 	ErrorException(const string &what_arg); //for windows
-	ErrorException(string what_file,string what_function,int what_line,string what_arg);//UNIX
+	ErrorException(const string&  what_file,const string& what_function,int what_line,const string& what_arg);//UNIX
 	~ErrorException() throw();
 	virtual const char *what() const throw();
Index: issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/exprintf.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/exprintf.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Exceptions/exprintf.cpp	(revision 12878)
@@ -9,4 +9,5 @@
 #include <stdarg.h>
 #include <stdio.h>
+#include "../Alloc/xNewDelete.h"
 #include "../Alloc/alloc.h"
 
@@ -14,17 +15,37 @@
 
 	/*returned string: */
-	char* string=NULL;
+	char *buffer = NULL;
+	int   n,size = 100;
+	int   string_size;
 
-	/*Assum nobody will print more that 1024 characters!*/
-	string=(char*)xmalloc(1024*sizeof(char));//assume that nobody will print more than 1024 characters at once.
-                                                                                                                                                                                                     
 	//variable list of arguments
-	va_list ap;
+	va_list args;
 
-	//First use vsprintf to get the whole input string.
-	va_start(ap,format);
-	vsprintf(string,format,ap); //printf style coding 
-	va_end(ap); 
+	while(true){
 
-	return string;
+		/*allocate buffer for given string size*/
+		buffer=xNew<char>(size);
+
+		/* Try to print in the allocated space. */
+		va_start(args, format);
+#ifndef WIN32
+		n=vsnprintf(buffer,size,format,args);
+#else
+		n=vsnprintf(buffer,size,format,args);
+#endif
+		va_end(args);
+
+		/* If that worked, return the string. */
+		if(n>-1 && n<size) break;
+
+		/* Else try again with more space. */
+		if(n>-1)   /* glibc 2.1 */
+		 size=n+1; /* precisely what is needed */
+		else       /* glibc 2.0 */
+		 size*=2;  /* twice the old size */
+
+		xDelete<char>(buffer);
+	}
+
+	return buffer;
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/Exp/DomainOutlineRead.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Exp/DomainOutlineRead.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Exp/DomainOutlineRead.cpp	(revision 12878)
@@ -7,7 +7,8 @@
 
 #include <stdio.h>
+#include <cstring> 
 #include "../Alloc/alloc.h"
 #include "../../include/include.h"
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 #include "../Exceptions/exceptions.h"
 #include "../../Container/DataSet.h"
@@ -19,24 +20,24 @@
 
 	/*I/O: */
-	FILE* fid=NULL;
-	char chardummy[256];
+	FILE   *fid = NULL;
+	char    chardummy[256];
 	double  ddummy;
 
 	/*output: */
-	int nprof; //number of profiles in the domainname file
-	int* profnvertices=NULL; //array holding the number of vertices for the nprof profiles
-	double** pprofx=NULL; //array of profiles x coordinates
-	double** pprofy=NULL; //array of profiles y coordinates
-	bool* closed=NULL; //array holding closed flags for the nprof profiles
+	int      nprof;                //number of profiles in the domainname file
+	int     *profnvertices = NULL; //array holding the number of vertices for the nprof profiles
+	double **pprofx        = NULL; //array of profiles x coordinates
+	double **pprofy        = NULL; //array of profiles y coordinates
+	bool    *closed        = NULL; //array holding closed flags for the nprof profiles
 
 	/*For each profile: */
-	int n;
-	double* x=NULL;
-	double* y=NULL;
-	bool cl;
+	int     n;
+	double *x  = NULL;
+	double *y  = NULL;
+	bool    cl;
 
 	/*open domain outline file for reading: */
 	if ((fid=fopen(domainname,"r"))==NULL){
-		_error_("%s%s","could not find domain file ",domainname); 
+		_error2_("could not find domain file " << domainname); 
 	}
 
@@ -61,12 +62,12 @@
 	
 	/*Allocate and initialize all the profiles: */
-	profnvertices=(int*)xmalloc(nprof*sizeof(int));
-	pprofx=(double**)xmalloc(nprof*sizeof(double*));
-	pprofy=(double**)xmalloc(nprof*sizeof(double*));
+	profnvertices=xNew<int>(nprof);
+	pprofx=xNew<double*>(nprof);
+	pprofy=xNew<double*>(nprof);
 	for (i=0;i<nprof;i++){
 		pprofx[i]=NULL;
 		pprofy[i]=NULL;
 	}
-	closed=(bool*)xmalloc(nprof*sizeof(bool));
+	closed=xNew<bool>(nprof);
 
 	/*Reaset file pointer to beginning of file: */
@@ -88,8 +89,7 @@
 
 		/*Allocate vertices: */
-		x=(double*)xmalloc(n*sizeof(double));
-		y=(double*)xmalloc(n*sizeof(double));
+		x=xNew<double>(n);
+		y=xNew<double>(n);
 		
-
 		/*Read vertices: */
 		for (i=0;i<n;i++){
@@ -118,6 +118,8 @@
 	*ppprofx=pprofx;
 	*ppprofy=pprofy;
-	if(pclosed)*pclosed=closed;
-	else       xfree((void**)&closed);
+	if(pclosed)
+	 *pclosed=closed;
+	else
+	 xDelete<bool>(closed);
 }
 
Index: issm/branches/trunk-jpl-damage/src/c/shared/Exp/DomainOutlineWrite.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Exp/DomainOutlineWrite.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Exp/DomainOutlineWrite.cpp	(revision 12878)
@@ -23,5 +23,5 @@
 	/*open domain outline file for writing: */
 	if ((fid=fopen(domainname,"w"))==NULL){
-		_error_("%s%s","could not open domain file ",domainname); 
+		_error2_("could not open domain file " << domainname); 
 		noerr=0; goto cleanupandreturn;
 	}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Exp/IsInPoly.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Exp/IsInPoly.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Exp/IsInPoly.cpp	(revision 12878)
@@ -14,5 +14,5 @@
 #endif
 
-/*IsInPoly {{{1*/
+/*IsInPoly {{{*/
 int IsInPoly(Vector* in,double* xc,double* yc,int numvertices,double* x,double* y,int i0,int i1, int edgevalue){
 
@@ -55,5 +55,5 @@
 	 return 1;
 }/*}}}*/
-/*IsOutsidePoly {{{1*/
+/*IsOutsidePoly {{{*/
 int IsOutsidePoly(Vector* in,double* xc,double* yc,int numvertices,double* x,double* y,int i0,int i1, int edgevalue){
 
@@ -96,5 +96,5 @@
 	return 1;
 }/*}}}*/
-/*pnpoly{{{1*/
+/*pnpoly{{{*/
 int pnpoly(int npol, double *xp, double *yp, double x, double y, int edgevalue) {
 	int i, j, c = 0;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Exp/exp.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Exp/exp.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Exp/exp.h	(revision 12878)
@@ -7,5 +7,5 @@
 #define _EXP_H_
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../toolkits/toolkits.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/shared/Matrix/MatrixUtils.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Matrix/MatrixUtils.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Matrix/MatrixUtils.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 /*Headers*/
-/*{{{1*/
+/*{{{*/
 #include "./matrix.h"
 #include "../Exceptions/exceptions.h"
@@ -16,10 +16,10 @@
 /*}}}*/
 
-/*FUNCTION TripleMultiply {{{1*/
-int TripleMultiply( double* a, int nrowa, int ncola, int itrna, double* b, int nrowb, int ncolb, int itrnb, double* c, int nrowc, int ncolc, int itrnc, double* d, int iaddd){
+/*FUNCTION TripleMultiply {{{*/
+int TripleMultiply( IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int nrowc, int ncolc, int itrnc, IssmDouble* d, int iaddd){
 	/*TripleMultiply    Perform triple matrix product a*b*c+d.*/
 	
 	int idima,idimb,idimc,idimd;
-	double* dtemp;
+	IssmDouble* dtemp;
 
 /*  set up dimensions for triple product  */
@@ -36,5 +36,5 @@
 	if (!itrnb) {
 		if (nrowb != idimb) {
-			_error_("Matrix A and B inner vectors not equal size.");
+			_error2_("Matrix A and B inner vectors not equal size.");
 		}
 		idimc=ncolb;
@@ -42,5 +42,5 @@
 	else {
 		if (ncolb != idimb) {
-			_error_("Matrix A and B inner vectors not equal size.");
+			_error2_("Matrix A and B inner vectors not equal size.");
 		}
 		idimc=nrowb;
@@ -49,5 +49,5 @@
 	if (!itrnc) {
 		if (nrowc != idimc) {
-			_error_("Matrix B and C inner vectors not equal size.");
+			_error2_("Matrix B and C inner vectors not equal size.");
 		}
 		idimd=ncolc;
@@ -55,5 +55,5 @@
 	else {
 		if (ncolc != idimc) {
-			_error_("Matrix B and C inner vectors not equal size.");
+			_error2_("Matrix B and C inner vectors not equal size.");
 		}
 		idimd=nrowc;
@@ -62,6 +62,6 @@
 /*  perform the matrix triple product in the order that minimizes the
 	number of multiplies and the temporary space used, noting that
-	(a*b)*c requires ac(b+d) multiplies and ac doubles, and a*(b*c)
-	requires bd(a+c) multiplies and bd doubles (both are the same for
+	(a*b)*c requires ac(b+d) multiplies and ac IssmDoubles, and a*(b*c)
+	requires bd(a+c) multiplies and bd IssmDoubles (both are the same for
 	a symmetric triple product)  */
 
@@ -69,14 +69,9 @@
 
 	if (idima*idimc*(idimb+idimd) <= idimb*idimd*(idima+idimc)) {
-		dtemp=(double *) xmalloc(idima*idimc*sizeof(double));
-
-		MatrixMultiply(a    ,nrowa,ncola,itrna,
-				   b    ,nrowb,ncolb,itrnb,
-				   dtemp,0);
-		MatrixMultiply(dtemp,idima,idimc,0    ,
-				   c    ,nrowc,ncolc,itrnc,
-				   d    ,iaddd);
-
-		xfree((void **)&dtemp);
+		dtemp=xNew<IssmDouble>(idima*idimc);
+
+		MatrixMultiply(a,nrowa,ncola,itrna,b,nrowb,ncolb,itrnb,dtemp,0);
+		MatrixMultiply(dtemp,idima,idimc,0,c,nrowc,ncolc,itrnc,d,iaddd);
+		xDelete<IssmDouble>(dtemp);
 	}
 
@@ -84,20 +79,15 @@
 
 	else {
-		dtemp=(double *) xmalloc(idimb*idimd*sizeof(double));
-
-		MatrixMultiply(b    ,nrowb,ncolb,itrnb,
-				   c    ,nrowc,ncolc,itrnc,
-				   dtemp,0);
-		MatrixMultiply(a    ,nrowa,ncola,itrna,
-				   dtemp,idimb,idimd,0    ,
-				   d    ,iaddd);
-
-		xfree((void **)&dtemp);
+		dtemp=xNew<IssmDouble>(idimb*idimd);
+
+		MatrixMultiply(b,nrowb,ncolb,itrnb,c,nrowc,ncolc,itrnc,dtemp,0);
+		MatrixMultiply(a,nrowa,ncola,itrna,dtemp,idimb,idimd,0,d,iaddd);
+		xDelete<IssmDouble>(dtemp);
 	}
 
 	return 1;
 }/*}}}*/
-/*FUNCTION MatrixMuliply {{{1*/
-int MatrixMultiply( double* a, int nrowa, int ncola, int itrna, double* b, int nrowb, int ncolb, int itrnb, double* c, int iaddc ){
+/*FUNCTION MatrixMuliply {{{*/
+int MatrixMultiply( IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int iaddc ){
 	/*MatrixMultiply    Perform matrix multiplication a*b+c.*/
 	int noerr=1;
@@ -134,5 +124,5 @@
 
 	if (ntrma != ntrmb) {
-		_error_("Matrix A and B inner vectors not equal size");
+		_error2_("Matrix A and B inner vectors not equal size");
 	    noerr=0;	
 		return noerr;
@@ -167,6 +157,6 @@
 	return noerr;
 }/*}}}*/
-/*FUNCTION MatrixInverse {{{1*/
-int MatrixInverse( double* a, int ndim, int nrow, double* b, int nvec, double* pdet ){
+/*FUNCTION MatrixInverse {{{*/
+int MatrixInverse( IssmDouble* a, int ndim, int nrow, IssmDouble* b, int nvec, IssmDouble* pdet ){
 /* MatrixInverse    Perform matrix inversion and linear equation solution.
 
@@ -181,9 +171,9 @@
 	int noerr=1;
 	int i,j,k,ipt,jpt,irow,icol,ipiv,ncol;
-	int (*pivrc)[2],*pindx;
-	double pivot,det,dtemp;
+	int *pivrc1,*pivrc2,*pindx;
+	IssmDouble pivot,det,dtemp;
 
 	if (!b && nvec) {
-		_error_("No right-hand side for nvec=%d.",nvec);
+		_error2_("No right-hand side for nvec=" << nvec << ".");
 		noerr=0;
 		return noerr;
@@ -198,7 +188,7 @@
 	ncol=nrow;
 	det=1.;
-
-	pivrc = (int (*)[2]) xmalloc((nrow*2)*sizeof(int));
-	pindx = (int (*)   ) xcalloc( nrow   ,sizeof(int));
+	pivrc1 =xNew<int>(nrow);
+	pivrc2 =xNew<int>(nrow);
+	pindx =xNew<int>(nrow);
 
 /*  loop over the rows/columns of the matrix  */
@@ -221,13 +211,14 @@
 
 		if (fabs(pivot) < DBL_EPSILON) {
-			xfree((void **)&pivrc);
-			xfree((void **)&pindx);
-			_error_("Pivot %f less than machine epsilon",pivot);
+			xDelete<int>(pivrc1);
+			xDelete<int>(pivrc2);
+			xDelete<int>(pindx);
+			_error2_("Pivot " << pivot << " less than machine epsilon");
 			noerr=0;
 			return noerr;
 		}
 
-		pivrc[i][0]=irow;
-		pivrc[i][1]=icol;
+		pivrc1[i]=irow;
+		pivrc2[i]=icol;
 
 		ipiv=icol;
@@ -319,7 +310,7 @@
 		j=(nrow-1)-i;
 
-		if (pivrc[j][0] != pivrc[j][1]) {
-			irow=pivrc[j][0];
-			icol=pivrc[j][1];
+		if (pivrc1[j] != pivrc2[j]) {
+			irow=pivrc1[j];
+			icol=pivrc2[j];
 
 //			_printf_(true,"column switch back for j=%d: irow=%d, icol=%d\n",
@@ -336,14 +327,12 @@
 	}
 
-	if (pdet)
-		*pdet=det;
-
-	xfree((void **)&pivrc);
-	xfree((void **)&pindx);
-
+	if (pdet) *pdet=det;
+	xDelete<int>(pivrc1);
+	xDelete<int>(pivrc2);
+	xDelete<int>(pindx);
 	return noerr;
 }/*}}}*/
-/*FUNCTION Matrix2x2Determinant(double* Adet,double* A) {{{1*/
-void Matrix2x2Determinant(double* Adet,double* A){
+/*FUNCTION Matrix2x2Determinant(IssmDouble* Adet,IssmDouble* A) {{{*/
+void Matrix2x2Determinant(IssmDouble* Adet,IssmDouble* A){
 	/*Compute determinant of a 2x2 matrix*/
 
@@ -352,13 +341,13 @@
 }
 /*}}}*/
-/*FUNCTION Matrix2x2Invert(double* Ainv,double* A) {{{1*/
-void Matrix2x2Invert(double* Ainv,double* A){
+/*FUNCTION Matrix2x2Invert(IssmDouble* Ainv,IssmDouble* A) {{{*/
+void Matrix2x2Invert(IssmDouble* Ainv,IssmDouble* A){
 
 	/*Intermediaries*/
-	double det;
+	IssmDouble det;
 
 	/*Compute determinant*/
 	Matrix2x2Determinant(&det,A);
-	if (fabs(det) < DBL_EPSILON) _error_("Determinant smaller that machine epsilon");
+	if (fabs(det) < DBL_EPSILON) _error2_("Determinant smaller that machine epsilon");
 
 	/*Compute invert*/
@@ -369,6 +358,6 @@
 
 }/*}}}*/
-/*FUNCTION Matrix3x3Determinant(double* Adet,double* A) {{{1*/
-void Matrix3x3Determinant(double* Adet,double* A){
+/*FUNCTION Matrix3x3Determinant(IssmDouble* Adet,IssmDouble* A) {{{*/
+void Matrix3x3Determinant(IssmDouble* Adet,IssmDouble* A){
 	/*Compute determinant of a 3x3 matrix*/
 
@@ -377,13 +366,13 @@
 }
 /*}}}*/
-/*FUNCTION Matrix3x3Invert(double* Ainv,double* A) {{{1*/
-void Matrix3x3Invert(double* Ainv,double* A){
+/*FUNCTION Matrix3x3Invert(IssmDouble* Ainv,IssmDouble* A) {{{*/
+void Matrix3x3Invert(IssmDouble* Ainv,IssmDouble* A){
 
 	/*Intermediaries*/
-	double det;
+	IssmDouble det;
 
 	/*Compute determinant*/
 	Matrix3x3Determinant(&det,A);
-	if (fabs(det) < DBL_EPSILON) _error_("Determinant smaller that machine epsilon");
+	if (fabs(det) < DBL_EPSILON) _error2_("Determinant smaller that machine epsilon");
 
 	/*Compute invert*/
@@ -399,6 +388,6 @@
 
 }/*}}}*/
-/*FUNCTION MatrixTranspose(double* Adet,double* A) {{{1*/
-void MatrixTranspose(double* tA,double* A, int nrows, int ncols){
+/*FUNCTION MatrixTranspose(IssmDouble* Adet,IssmDouble* A) {{{*/
+void MatrixTranspose(IssmDouble* tA,IssmDouble* A, int nrows, int ncols){
 	/*Transpose a n*m matrix*/
 
Index: issm/branches/trunk-jpl-damage/src/c/shared/Matrix/matrix.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Matrix/matrix.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Matrix/matrix.h	(revision 12878)
@@ -6,12 +6,14 @@
 #define _MATRIXUTILS_H_
 
-int  TripleMultiply( double* a, int nrowa, int ncola, int itrna, double* b, int nrowb, int ncolb, int itrnb, double* c, int nrowc, int ncolc, int itrnc, double* d, int iaddd);
-int  MatrixMultiply( double* a, int nrowa, int ncola, int itrna, double* b, int nrowb, int ncolb, int itrnb, double* c, int iaddc );
-int  MatrixInverse( double* a, int ndim, int nrow, double* b, int nvec, double* pdet );
-void Matrix2x2Invert(double* Ainv, double* A);
-void Matrix2x2Determinant(double* Adet,double* A);
-void Matrix3x3Invert(double* Ainv, double* A);
-void Matrix3x3Determinant(double* Adet,double* A);
-void MatrixTranspose(double* tA,double* A,int nrows, int ncols);
+#include "../../include/include.h"
+
+int  TripleMultiply( IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int nrowc, int ncolc, int itrnc, IssmDouble* d, int iaddd);
+int  MatrixMultiply( IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int iaddc );
+int  MatrixInverse( IssmDouble* a, int ndim, int nrow, IssmDouble* b, int nvec, IssmDouble* pdet );
+void Matrix2x2Invert(IssmDouble* Ainv, IssmDouble* A);
+void Matrix2x2Determinant(IssmDouble* Adet,IssmDouble* A);
+void Matrix3x3Invert(IssmDouble* Ainv, IssmDouble* A);
+void Matrix3x3Determinant(IssmDouble* Adet,IssmDouble* A);
+void MatrixTranspose(IssmDouble* tA,IssmDouble* A,int nrows, int ncols);
 
 #endif //ifndef _MATRIXUTILS_H_
Index: issm/branches/trunk-jpl-damage/src/c/shared/MemOps/xMemCpy.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/MemOps/xMemCpy.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/MemOps/xMemCpy.h	(revision 12878)
@@ -0,0 +1,19 @@
+/* \file xMemCpy.h
+ * \brief: header file for templated memory operations
+ */
+
+#ifndef _XMEMCPY_H_
+#define _XMEMCPY_H_
+
+#include <cassert>
+
+template <class T> 
+T* xMemCpy(T* dest, const T* src, unsigned int size) {
+  assert(dest); assert(src);
+  for (int i=0; i<size;++i) 
+    dest[i]=src[i];
+  return dest;
+};
+
+#endif
+
